/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

// PushCheck.cpp : implementation file
//

#include "stdafx.h"
#include "PushCheck.h"
#include "notify/checknet.h"

// CPushCheck dialog

IMPLEMENT_DYNAMIC(CPushCheck, CDialog)

CPushCheck::CPushCheck(CWnd* pParent /*=NULL*/)
	: CDialog(CPushCheck::IDD, pParent)
{

}

CPushCheck::~CPushCheck()
{
}

void CPushCheck::DoDataExchange(CDataExchange* pDX){
	CDialog::DoDataExchange(pDX);
}

BOOL CPushCheck::OnInitDialog(){
    CString s1;

    CDialog::OnInitDialog();

    s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_PUSH_CHECKING_NETWORK); SetDlgItemText(IDC_PUSH_STATIC_CHECKING,s1);

    LOGFONT lf;
    memset(&lf, 0, sizeof(LOGFONT));
    HFONT hFont = (HFONT) GetStockObject(SYSTEM_FONT);
    GetObject(hFont, sizeof lf, &lf);
    lf.lfWeight = FW_BOLD;
    lf.lfHeight +=FONT_HEIGHT_OFFSET;
    VERIFY(fontBold.CreateFontIndirect(&lf));

    GetDlgItem(IDC_PUSH_STATIC_CHECKING)->SetFont(&fontBold);

    SHMENUBARINFO dlgCommandBar;
    ZeroMemory(&dlgCommandBar, sizeof(SHMENUBARINFO));
    dlgCommandBar.cbSize = sizeof(SHMENUBARINFO);
    dlgCommandBar.hwndParent = this->GetSafeHwnd();
    dlgCommandBar.dwFlags = SHCMBF_HMENU;
    dlgCommandBar.nToolBarId = IDM_OKCANCEL;
    #if defined WIN32_PLATFORM_WFSP
    #if (_WIN32_WCE < 0x500)
        dlgCommandBar.nToolBarId = IDR_MENUBAR_OKCANCEL;
    #endif
    #endif
    dlgCommandBar.hInstRes = getLocalizationUtils()->getLocaleResource();
    dlgCommandBar.nBmpId = 0;
    dlgCommandBar.cBmpImages = 0;
    if(!SHCreateMenuBar(&dlgCommandBar)){
        TRACE(_T("Cannot create command bar!"));
        return FALSE;
    };


    TBBUTTONINFO tbi;

    memset (&tbi, 0, sizeof (tbi));
    tbi.cbSize = sizeof (tbi);
    tbi.dwMask = TBIF_STATE;
    ::SendMessage (dlgCommandBar.hwndMB, TB_GETBUTTONINFO, IDOK, (LPARAM)&tbi);
    tbi.fsState &= ~TBSTATE_ENABLED;
    ::SendMessage (dlgCommandBar.hwndMB, TB_SETBUTTONINFO, IDOK, (LPARAM)&tbi);

    memset (&tbi, 0, sizeof (tbi));
    tbi.cbSize = sizeof (tbi);
    tbi.dwMask = TBIF_STATE;
    ::SendMessage (dlgCommandBar.hwndMB, TB_GETBUTTONINFO, IDCANCEL, (LPARAM)&tbi);
    tbi.fsState &= ~TBSTATE_ENABLED;
    ::SendMessage (dlgCommandBar.hwndMB, TB_SETBUTTONINFO, IDCANCEL, (LPARAM)&tbi);

    SetTimer(1000, 100, NULL);

    return FALSE;
}

BEGIN_MESSAGE_MAP(CPushCheck, CDialog)
    ON_WM_TIMER()
END_MESSAGE_MAP()


// CPushCheck message handlers

void CPushCheck::OnTimer( UINT_PTR nIDEvent ){
    KillTimer(1000);

    if(checkNetwork())
        EndDialog(PUSH_NETWORK_AVAILABLE);
    else
        EndDialog(PUSH_NETWORK_UNAVAILABLE);
}
