/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */
#include "stdafx.h"
#include "SynchronizationMessages.h"
#include "ui.h"

CString SyncErrorMsg(long code)
{
    CString s1("");
    switch(code)
    {
    case 0:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_OK_0); break;
    case -10:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_NOSOURCE_10); break;
    case -6:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_SYNC_STOPPED);break;
    
    case 402:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_AUTH_EXPIRED_402); break;
    case 403:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_FORBIDDEN_403); break;

    case 404:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_NOTFOUND_404); break;


    case 407:
    case 401:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_INVALID_CREDENTIALS_401); break;

    case 417:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_ERROR_SYNC_417); break;

    case 503:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_SERVER_BUSY_503); break;
// TODO: get the message from the server?
//    case 506:
//        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_BACKEND_ERROR_506); break;
    case 588:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_ERROR_EMAIL_588);break;

    case 2001:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_ERROR_CONNECT_2001); break;
    case 2060:      // Server path is wrong
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_ERROR_CONNECT_2001); break;
    case 2061:      // Server timeout
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_ERROR_SYNC_2061); break;
    case 2002:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_ERROR_READING_CONTENT_2002); break;
    case 2003:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_SERVER_NOT_FOUND_2003); break;
    case 2005:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_INTERNET_CONNECTION_MISSING_2005); break;
    case 2007:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_NETWORK_ERROR_2007); break;
    case 2052:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_SERVER_ERROR_2052); break;

    case 12029: //ERROR_INTERNET_CANNOT_CONNECT  *** deprecated: use only code 2001 ***
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_ERROR_INTERNET_CANNOT_CONNECT_12019); break;
// TODO: add a message for this.
//    case 12007:
//        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_ERROR_RESOLVE_NAME);
//        break;

    case -30:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_SYNC_STOPPED);break;
    case -40:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_OUT_OF_MEMORY);break;
    case -50:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_ERR_LOW_MEM);break;
    case -25:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_BRIEFCASE_DIR_DOESNT_EXIST);break;
    case -26:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_NOTE_DIR_DOESNT_EXIST);break;
    //case 10003:
        //s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_NO_SOURCES_10003); break;
    default:
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CODE_ERROR_NOT_DONE); break;
    }

    return s1;
}