/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

#pragma once

#include "ui.h"


CString getActiveSyncMethod();


// CSyncSettingsAdvanced dialog
class CSyncSettingsAdvanced : public CDialog
{
    DECLARE_DYNAMIC(CSyncSettingsAdvanced)

public:
    CSyncSettingsAdvanced(CWnd* pParent = NULL);   // standard constructor
    virtual ~CSyncSettingsAdvanced();

// Dialog Data
    enum { IDD = IDD_UI_SYNC_ADVANCED };

protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    virtual BOOL OnInitDialog();


    SHMENUBARINFO dlgCommandBar;

    CButton checkEncryption;
    CButton radioContactSIF;
    CButton radioContactVCard;
    CButton radioCalendarSIF;
    CButton radioCalendarVCard;
    CButton radioTaskSIF;
    CButton radioTaskVCard;

    CEdit textEmail;
    CEdit textContact;
    CEdit textCalendar;
    CEdit textTask;
    CEdit textBriefcase;

#if defined(WIN32_PLATFORM_PSPC)
    CButton radioNoteSIF;
    CButton radioNoteVCard;
    CEdit   textNotes;
#endif
    CFont fontBold;

    /// store boolean value, indicates if cradle was enabled when entering the dialog
    bool cradleInitiallyEnabled;
    
    /// store what was the initial selection in the scheduler settings when entering the dialog
    int initialSchedulerSelection;

    /// store what was the initial selection in the lstSyncMethod list when entering the dialog
    int initialSyncMethodSelection;

    // For scrollbar control
    int dlgCurrentHeight;
    int dlgMaxHeight;
    int scrollbarPosition;
    CRect dlgRect;


 DECLARE_MESSAGE_MAP()

    afx_msg void OnOK();
    afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
    afx_msg void OnSize(UINT nType, int cx, int cy);
    HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);

private:
    HINSTANCE localResource;
#if defined(WIN32_PLATFORM_PSPC)
    void setScrollOnFocus(int objectIDC);
#endif

public:

#if defined(WIN32_PLATFORM_WFSP)
    LRESULT OnHotkey(WPARAM wParam, LPARAM lParam);
#endif
#if defined(WIN32_PLATFORM_PSPC)
    afx_msg void OnBnSetfocusEncryption();
    afx_msg void OnEnSetfocusEditMail();
    afx_msg void OnEnSetfocusEditContact();
    afx_msg void OnEnSetfocusEditCalendar();
    afx_msg void OnEnSetfocusEditTask();
    afx_msg void OnEnSetfocusEditNote();
    afx_msg void OnEnSetfocusEditBriefcase();
    afx_msg void OnBnSetfocusRadioContactSif();
    afx_msg void OnBnSetfocusRadioContactVcard();
    afx_msg void OnBnSetfocusRadioCalendarSif();
    afx_msg void OnBnSetfocusRadioCalendarVcard();
    afx_msg void OnBnSetfocusRadioTaskSif();
    afx_msg void OnBnSetfocusRadioTaskVcard();
    afx_msg void OnBnSetfocusRadioNoteSif();
    afx_msg void OnBnSetfocusRadioNoteVcard();
#endif
};
