/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */
#include "base/util/utils.h"
#include "pim/mail/MailClientData.h"

MailClientData::MailClientData(const wchar_t *id) {
    entryId = wstrdup(id);
    folder = NULL;
    emailData = new EmailData();
    maxMailMessageSize = 0;
    currentMessageSizeFilter = 0;
    isSyncInclusive = false;
    includeAttachment = false;
}

MailClientData::~MailClientData() {
    if (folder)
        delete [] folder;
    if (entryId)
        delete [] entryId;
    delete emailData;
    emailData = NULL;

}

void MailClientData::setEmailData(EmailData* t) {
    if (emailData) {
        delete emailData;
    }
    emailData = (EmailData*)t->clone();
}

EmailData* MailClientData::getEmailData() const {
    return emailData;
}

const wchar_t * MailClientData::getEntryId() const {
    return entryId;
}

void MailClientData::setParent(const wchar_t* t) {
    if (folder)
        delete [] folder;
    folder = wstrdup(t);
}

void MailClientData::setParent(wchar_t t) {
    if (folder)
        delete [] folder;

    folder = new wchar_t[2];
    wsprintf(folder, TEXT("%c"), t);
}

const wchar_t* MailClientData::getParent() const {
    return folder;
}
