/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission 
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE 
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite 
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably 
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

#ifndef INCL_BRANDING_PARAMS
#define INCL_BRANDING_PARAMS
    
#include <string>

using namespace std;

class BrandingParams {
    
private:
    
    /**
    * Says we have to show the url field in the settings screen
    */
    string showUrlField;
    
    /**
    * Says if we have to show the note source in the main screen and in the settings
    */
    string showNoteSource;
    
    /**
    * Says if we have to show the briefcase source in the main screen and in the settings   
    */
    string showBriefcaseSource;
    
    /**
    * Says if we have to show the advanced settings menu the settings screen
    */            
    string showAdvSettingMenu;
         
    
public:
    
    BrandingParams(bool readFromRegistry = true);

    ~BrandingParams();
    
    void setShowUrlField(string v) {showUrlField = v; }
    void setShowUrlField(const char* v) {if (v) {showUrlField = v;} }
    __declspec(dllexport) bool getShowUrlField() {return showUrlField == "0" ? false : true; }        
 
    void setShowNoteSource(string v) {showNoteSource = v; }
    void setShowNoteSource(const char* v) {if (v) {showNoteSource = v;}}
    __declspec(dllexport) bool getShowNoteSource() {return showNoteSource == "0" ? false : true; }        
 
    void setShowBriefcaseSource(string v) {showBriefcaseSource = v; }
    void setShowBriefcaseSource(const char* v) {if (v) {showBriefcaseSource = v;}}
    __declspec(dllexport) bool getShowBriefcaseSource() {return showBriefcaseSource == "0" ? false : true; }        
    
    void setShowAdvSettingMenu(string v) {showAdvSettingMenu = v; }
    void setShowAdvSettingMenu(const char* v) {if (v) {showAdvSettingMenu = v;}}
    __declspec(dllexport) bool getShowAdvSettingMenu() {return showAdvSettingMenu == "0" ? false : true; }        
 
    
   
    
};
    
#endif

