/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

//
// @author Marco Magistrali
//
#ifndef INCL_FILEFILEMANAGEMENT
    #define INCL_FILEFILEMANAGEMENT

    #define DIMLINE 512

    int writeTextToFile(const wchar_t* filename, const wchar_t* text);

    wchar_t* readTextFromBinaryFile(wchar_t* filename);

    void writeTextToTextFile(wchar_t* fName, wchar_t* text);


    BOOL getFileList(wchar_t *dir, wchar_t** ptrArray, int* count,
                BOOL onlyFilesNumber, BOOL isRecursiveInDirectory);

    BOOL getFileList(wchar_t *dir, wchar_t** ptrArray, int *count,
                BOOL onlyFilesNumber, BOOL isRecursiveInDirectory, wchar_t* filter);

    BOOL getLastWriteTime(wchar_t* filename, wchar_t* wtime, DATE* dtime);

    BOOL getFileSize(wchar_t* filename, unsigned long *size);

    // read and write binary data from / into file
    void readByteFromFile(wchar_t* fName, byte *ptr, int* numBytes);
    void writeByteToFile (wchar_t* fName, byte *ptr, int numBytes);

    // write current items (fileName) into file to use to compare name and date...
    void writeCurrentFileItems(int dataType, const wchar_t* path, const wchar_t* dir);

    // read fileName from file
    // the first element is the timestamp of last sync
    int readFilenameFromFile(int dataType, const wchar_t* path, wchar_t*** ptrArrayFilename);

    /*
    * The key can be a file name so it can contain some special char to be encoded.
    * The method get an array of wchar and overwrite the current key with the encoded one.
    */
    void encodeKey(wchar_t* key);

    /*
    * The key can be a file name so it can contain some special char to be encoded.
    * The method get an array of wchar and overwrite the current key with the encoded one.
    */
    void decodeKey(wchar_t* key);
    char* readTextFromBinaryFileChar(wchar_t* filename);

#endif

