/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */
// setup.h : main header file for the SETUP DLL
//


#ifndef REGISTRY_H
    #define REGISTRY_H
    #define PROGRAM_DIR TEXT("Funambol")


    void setPropertyValue(const wchar_t*  context, const wchar_t*  prop, const wchar_t* value, bool backup = false);
    wchar_t* readPropertyValue(const wchar_t* fullContext, const wchar_t*  prop);
    void createAllRegistry(bool backup = false);
    void createAllRegistryBackup();
    void deleteAllRegistry();
    void updateNewRegistry();

    void deleteSyncmlTransportRegistry();

    void deleteAllRegistry();

    void createSyncmlTransportRegistry();
    const wchar_t* getAppName();
    const wchar_t* getFullReg(wchar_t* val);



    static size_t getLenEncoding(const WCHAR* s);
    char* toMultibyte(const WCHAR *wc);  
    WCHAR* toWideChar(const char *mb);

    bool backupRegistry30();
    bool backupRegistryVersion();
    bool restoreRegistryVersion();
    bool removeBackupRegistryVersion();
    bool removeEntryOfUninstall30(wchar_t* installedName);

    wchar_t** getChildrenNames();

    // set in the backup registry if the previous plug-in is from 3.0 version
    BOOL isFrom30();
    void setFrom30();



#endif
