/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

#ifndef __PUSHMESSAGE_H__
#define __PUSHMESSAGE_H__

#include <windows.h>
#include "pushclient.h"
#include "syncml/core/SyncNotification.h"
#include "spds/constants.h"
#include "spdm/DMTree.h"
#include "spdm/DMTreefactory.h"
#include "base/Log.h"
#include "pim/utils.h"
#include "base/util/utils.h"

TCHAR const c_szAppId[] = TEXT("x-wap-application:push.syncml");
TCHAR const c_szContentType[] = TEXT("");
//TCHAR const c_szAppIdOTA[] = TEXT("application/vnd.wap.connectivity-wbxml");
//TCHAR const c_szContentTypeOTA[] = TEXT("");
TCHAR const c_szAppIdOTA[] = TEXT("x-wap-application:push.syncml");
TCHAR const c_szContentTypeOTA[] = TEXT("application/vnd.wap.connectivity-wbxml");


//
// For Smartphone 2003 is not possible match appID and contentType together.
// So we get the appID only (and contentType = ""
//
//TCHAR const c_szContentType[] = TEXT("application/vnd.syncml.ds.notification");

TCHAR const c_szPath[] = TEXT("\\Programmi\\Funambol\\startsync.exe");
TCHAR const c_szParams[] = TEXT("wap_push");
TCHAR const c_szParamsOTA[] = TEXT("OTA_config");

int handleWapPushMessage(LPPUSHMSG pPushMsg, wchar_t*** sources);

static wchar_t *getSourceName(const char *root, const char *uri);

#endif

